Главная » Delphi, OLE, САПР » Оболочка – КОМПАС в DELPHI

0

Параметры оболочки (ksShellDefinition)

Интерфейс ksShellDefinition служит для описания параметров оболочки. Его возвращает метод GetDefinition() интерфейса ksEntity, описывающего оболочку. Рассмотрим свойства интерфейса ksShellDefinition.

thickness – толщина оболочки.

thinType – направление построения оболочки. Если значение данного свойства равно TRUE, то оболочка строится внутрь. Если же значение данного свойства равно FALSE, то оболочка строится наружу.

Метод у интерфейса ksShellDefinition всего один.

FaceArray() – возвращает интерфейс ksEntityCollection (см. главу 63) массива удаляемых граней детали.

Пример

Ниже представлен ключевой фрагмент исходного текста программы, демонстрирующей построение оболочки.

const

pTop_Part = -1;

o3d_planeXOY = 1;

o3d_sketch  = 5;

o3d_face = 6;

o3d_baseExtrusion = 24;

o3d_shellOperation = 43;

etBlind  = 0;

vm_Shaded = 3;

var

kompas: KompasObject; Document3D: ksDocument3D; Part: ksPart;

EntitySketch, EntityPlaneXOY, EntityExtrusion: ksEntity;

EntityShell: ksEntity; EntityCollectionShell,EntityCollectionPart: ksEntityCollection; SketchDefinition: ksSketchDefinition;

Document2D : ksDocument2D;

BaseExtrusionDefinition: ksBaseExtrusionDefinition; ShellDefinition: ksShellDefinition;

begin

//Подключаемся к КОМПАСу

kompas:=KompasObject(CreateOleObject(‘Kompas.Application.5′));

//Получаем интерфейс документа-модели

Document3D:=ksDocument3D(kompas.Document3D());

//Создаем документ-модель

Document3D.Create(FALSE,true);

//Получаем интерфейс компонента

Part:= ksPart(Document3D.GetPart(pTop_Part));

//Получаем интерфейс объекта "плоскость XOY"

EntityPlaneXOY:=ksEntity(Part.GetDefaultEntity(o3d_planeXOY));

/////////////////////////////////////////////////

//Эскиз

/////////////////////////////////////////////////

//Получаем интерфейс объекта "Эскиз"

EntitySketch:=ksEntity(Part.NewEntity(o3d_sketch));

//Получаем интерфейс параметров эскиза

SketchDefinition:=ksSketchDefinition(EntitySketch.GetDefinition());

//Устанавливаем плоскость XOY базовой для эскиза

SketchDefinition.SetPlane(EntityPlaneXOY);

//Создаем эскиз

EntitySketch.Create();

//Входим в режим редактирования эскиза

Document2D:=ksDocument2D(SketchDefinition.BeginEdit());

//Строим окружность

Document2D.ksCircle(0,0,15,1);

//Выходим из режима редактирования эскиза

SketchDefinition.EndEdit();

///////////////////////////////////////////////

//Операция "выдавливание"

//////////////////////////////////////////////

//Получаем интерфейс объекта "операция выдавливание"

EntityExtrusion:=ksEntity(Part.NewEntity(o3d_baseExtrusion));

//Получаем интерфейс параметров операции "выдавливание"

BaseExtrusionDefinition:=ksBaseExtrusionDefinition(EntityExtrusion.GetDefinition());

//Устанавливаем параметры операции выдавливания

BaseExtrusionDefinition.SetSideParam(TRUE,etBlind,50,0,TRUE);

//Устанавливаем эскиз операции выдавливания

BaseExtrusionDefinition.SetSketch(EntitySketch);

//Создаем операцию выдавливания

EntityExtrusion.Create();

//Получаем массив граней детали

EntityCollectionPart:=ksEntityCollection(Part.EntityCollection(o3d_face));

//////////////////////////////////////////////

//Оболочка

/////////////////////////////////////////////

//Получаем интерфейс объекта "оболочка"

EntityShell:=ksEntity(Part.NewEntity(o3d_shellOperation));

//Получаем интерфейс параметров объекта "оболочка"

ShellDefinition:=ksShellDefinition(EntityShell.GetDefinition());

//Толщина оболочки

ShellDefinition.thickness:=1;

//Направление – наружу

ShellDefinition.thinType:=FALSE;

//Получаем массив удаляемых граней

EntityCollectionShell:=ksEntityCollection(ShellDefinition.FaceArray());

EntityCollectionShell.Clear();

//Заполняем массив удаляемых граней

EntityCollectionShell.Add(EntityCollectionPart.GetByIndex(2));

//Создаем оболочку

EntityShell.Create();

end;

//Устанавливаем полутоновое изображение модели

Document3D.drawMode:=vm_Shaded;

//Включаем отображение каркаса

Document3D.shadedWireframe:=TRUE;

//Делаем КОМПАС видимым

kompas.Visible:=true;

На рисунке ниже показан результат работы этой программы.

Источник: Норсеев Сергей, «РАЗРАБОТКА ПРИЛОЖЕНИЙ ПОД КОМПАС В DELPHI»

По теме:

  • Комментарии